<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>e03 documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	   <link rel="stylesheet" href="../styles/style.css">
        <link rel="stylesheet" href="../styles/dark.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">e03 documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">








<ol class="breadcrumb">
  <li>Injectables</li>
  <li >AuthService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/core/services/auth.service.ts</code>
        </p>


            <p class="comment">
                <h3>Description</h3>
            </p>
            <p class="comment">
                <p>Service responsable de gérer l&#39;authentification avec OAuth</p>

            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Readonly</span>
                                <a href="#authConfig" >authConfig</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#configure" >configure</a>
                            </li>
                            <li>
                                <a href="#deconnexion" >deconnexion</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#essaiConnexion" >essaiConnexion</a>
                            </li>
                            <li>
                                <a href="#estConnecte" >estConnecte</a>
                            </li>
                            <li>
                                <a href="#initFlow" >initFlow</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#loadDiscoveryDocument" >loadDiscoveryDocument</a>
                            </li>
                            <li>
                                    <span class="modifier">Async</span>
                                <a href="#profil" >profil</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(oauthService: <a href="../injectables/AuthService.html" target="_self">OAuthService</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="34" class="link-to-prism">src/app/core/services/auth.service.ts:34</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div class="io-description"><p>Crée le service d&#39;authentification</p>
</div>
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                                    <td>Description</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>oauthService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/AuthService.html" target="_self" >OAuthService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                        <td>
                                                                <p>Référence au OAuthService de la librairie angular-oauth2-oidc</p>

                                                        </td>
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="configure"></a>
                    <span class="name">
                        <span ><b>configure</b></span>
                        <a href="#configure"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>configure()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="48"
                            class="link-to-prism">src/app/core/services/auth.service.ts:48</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Fonction appelée par le constructeur pour effectuer la configuration initiale et essayer de se connecter
si un utilisateur est authentifié (possède un id et access token).</p>
</div>

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="deconnexion"></a>
                    <span class="name">
                        <span ><b>deconnexion</b></span>
                        <a href="#deconnexion"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>deconnexion()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="57"
                            class="link-to-prism">src/app/core/services/auth.service.ts:57</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Déconnecte l&#39;utilisateur et vide la session</p>
</div>

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="essaiConnexion"></a>
                    <span class="name">
                        <span class="modifier">Async</span>
                        <span ><b>essaiConnexion</b></span>
                        <a href="#essaiConnexion"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>essaiConnexion()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="80"
                            class="link-to-prism">src/app/core/services/auth.service.ts:80</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Essai d&#39;authentifier l&#39;utilisateur à partir des jetons en session</p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;boolean&gt;</code>

                    </div>
                    <div class="io-description">
                        <p>Succès ou échec de la connexion sous forme de Promise</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="estConnecte"></a>
                    <span class="name">
                        <span ><b>estConnecte</b></span>
                        <a href="#estConnecte"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>estConnecte()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="64"
                            class="link-to-prism">src/app/core/services/auth.service.ts:64</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Vérifie si l&#39;utilisateur est connecté</p>
</div>

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="initFlow"></a>
                    <span class="name">
                        <span ><b>initFlow</b></span>
                        <a href="#initFlow"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>initFlow()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="72"
                            class="link-to-prism">src/app/core/services/auth.service.ts:72</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Initie l&#39;authentification avec une redirection vers Twitch pour authoriser l&#39;application à utiliser les données
de l&#39;utilisateur</p>
</div>

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="loadDiscoveryDocument"></a>
                    <span class="name">
                        <span class="modifier">Async</span>
                        <span ><b>loadDiscoveryDocument</b></span>
                        <a href="#loadDiscoveryDocument"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>loadDiscoveryDocument()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="88"
                            class="link-to-prism">src/app/core/services/auth.service.ts:88</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Charge le document de découverte contenant les détails du service OAuth de Twitch</p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;OAuthSuccessEvent&gt;</code>

                    </div>
                    <div class="io-description">
                        <p>Objet Promise avec le résultat du chargement</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="profil"></a>
                    <span class="name">
                        <span class="modifier">Async</span>
                        <span ><b>profil</b></span>
                        <a href="#profil"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>profil()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="32"
                            class="link-to-prism">src/app/core/services/auth.service.ts:32</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Retourne les détails du profil utilisateur connecté</p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>    <code>Promise&lt;object&gt;</code>

                    </div>
                    <div class="io-description">
                        <p>Objet Promise avec les informations du profil</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
            <section>
    
    <h3 id="inputs">
        Properties
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="authConfig"></a>
                    <span class="name">
                            <span class="modifier">Readonly</span>
                        <span ><b>authConfig</b></span>
                        <a href="#authConfig"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>    <code>AuthConfig</code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>{
    issuer: &#x27;https://id.twitch.tv/oauth2&#x27;,
    redirectUri: &#x27;http://localhost:4200/connexion&#x27;,
    clientId: &#x27;0lpyrdm8lfc5oucezpxurzbn8vnv6g&#x27;,
    scope: &#x27;openid&#x27;,
    showDebugInformation: true,
  }</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="20" class="link-to-prism">src/app/core/services/auth.service.ts:20</a></div>
                        </td>
                    </tr>

            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>Configuration OAuth pour Twitch</p>
<ul>
<li>issuer: L&#39;URL du service OAuth Twitch</li>
<li>redirectUri: URL de redirection lorsque l&#39;utilisateur aura approuvé</li>
<li>clientId: Le Client ID de l&#39;application enregistrée</li>
<li>scope: Les permissions demandées via le service (Twitch)</li>
<li>showDebugInformation: Si les informations de debug seront affichées dans la console</li>
</ul>
</div>
                </td>
            </tr>

        </tbody>
    </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &#x27;@angular/core&#x27;;
import {AuthConfig, OAuthService, OAuthSuccessEvent} from &quot;angular-oauth2-oidc&quot;;
import {JwksValidationHandler} from &quot;angular-oauth2-oidc-jwks&quot;;

/**
 * Service responsable de gérer l&#x27;authentification avec OAuth
 */
@Injectable({
  providedIn: &#x27;root&#x27;
})
export class AuthService {
  /**
   * Configuration OAuth pour Twitch
   * - issuer: L&#x27;URL du service OAuth Twitch
   * - redirectUri: URL de redirection lorsque l&#x27;utilisateur aura approuvé
   * - clientId: Le Client ID de l&#x27;application enregistrée
   * - scope: Les permissions demandées via le service (Twitch)
   * - showDebugInformation: Si les informations de debug seront affichées dans la console
   */
  readonly authConfig: AuthConfig &#x3D; {
    issuer: &#x27;https://id.twitch.tv/oauth2&#x27;,
    redirectUri: &#x27;http://localhost:4200/connexion&#x27;,
    clientId: &#x27;0lpyrdm8lfc5oucezpxurzbn8vnv6g&#x27;,
    scope: &#x27;openid&#x27;,
    showDebugInformation: true,
  };

  /**
   * Retourne les détails du profil utilisateur connecté
   * @return {Promise} Objet Promise avec les informations du profil
   */
  async profil(): Promise&lt;object&gt; {
    return this.oauthService.loadUserProfile();
  }

  /**
   * Crée le service d&#x27;authentification
   * @param oauthService Référence au OAuthService de la librairie angular-oauth2-oidc
   */
  constructor(private oauthService: OAuthService) {
    this.configure();
  }

  /**
   * Fonction appelée par le constructeur pour effectuer la configuration initiale et essayer de se connecter
   * si un utilisateur est authentifié (possède un id et access token).
   */
  configure() {
    this.oauthService.configure(this.authConfig);
    this.oauthService.tokenValidationHandler &#x3D; new JwksValidationHandler();
    this.oauthService.loadDiscoveryDocumentAndTryLogin();
  }

  /**
   * Déconnecte l&#x27;utilisateur et vide la session
   */
  deconnexion(): void {
    this.oauthService.logOut();
  }

  /**
   * Vérifie si l&#x27;utilisateur est connecté
   */
  estConnecte(): boolean {
    return this.oauthService.hasValidIdToken() &amp;&amp; this.oauthService.hasValidAccessToken();
  }

  /**
   * Initie l&#x27;authentification avec une redirection vers Twitch pour authoriser l&#x27;application à utiliser les données
   * de l&#x27;utilisateur
   */
  initFlow(): void {
    this.oauthService.initImplicitFlow();
  }

  /**
   * Essai d&#x27;authentifier l&#x27;utilisateur à partir des jetons en session
   * @return {Promise} Succès ou échec de la connexion sous forme de Promise
   */
  async essaiConnexion(): Promise&lt;boolean&gt; {
    return this.oauthService.loadDiscoveryDocumentAndTryLogin();
  }

  /**
   * Charge le document de découverte contenant les détails du service OAuth de Twitch
   * @return {Promise} Objet Promise avec le résultat du chargement
   */
  async loadDiscoveryDocument(): Promise&lt;OAuthSuccessEvent&gt; {
    return this.oauthService.loadDiscoveryDocument();
  }

}
</code></pre>
    </div>

</div>













                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'AuthService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>

       <script src="../js/menu-wc.js" defer></script>
       <script nomodule src="../js/menu-wc_es5.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
